
#2PLM(Mean and Sigma)
##################################################
pm <- read.csv("comitem.csv")
head(pm)
(Tm <- mean(pm[,2]))
(Ts <- sqrt(mean((pm[,2]-Tm)^2)))

(Fm <- mean(pm[,4]))
(Fs <- sqrt(mean((pm[,4]-Fm)^2)))

(A <- Ts/Fs)
(K <- Tm - (Fm*A))
##################################################


#graded response model(Mean and Sigma)
##################################################
pm <- read.csv("gradeex.csv")
(pm <- as.matrix(pm))
head(pm)

(Tm <- mean(pm[,2:3]))
(Ts <- sqrt(mean((pm[,2:3]-Tm)^2)))
(Fm <- mean(pm[,5:6]))
(Fs <- sqrt(mean((pm[,5:6]-Fm)^2)))

(A <- Ts/Fs)
(K <- Tm-(Fm*A))
##################################################


#(Mean and Mean)
##################################################
pm <- read.csv("comitem.csv")

(Tam <- mean(pm[,1]))
(Tbm <- mean(pm[,2]))

(Fam <- mean(pm[,3]))
(Fbm <- mean(pm[,4]))


(A <- Fam/Tam)
(K <- Tbm - Fbm*A)
##################################################


#Haebara(1980)
######################################################################
param <-read.csv("comitem.csv")
aT <- param[,1]
bT <- param[,2]
aF <- param[,3]
bF <- param[,4]

#quadrature point
p <- seq(-4,4,8/30)
w <- numeric(31)
for(i in 1:31)
{
	w[i] <- dnorm(p[i],0,1)*(8/30)
}

#ICC
icc2PL <- function(a,b,theta)
{
	res <-1/(1+exp(-1.7*a*(theta-b)))
	return(res)
}

icc2PL(a=c(0.8,0.8),b=c(-0.5,0.8),theta=0.3)

#criterion function
cf <- function(x,aF,bF,aT,bT)
{
	A <- x[1];K <- x[2]
	Q1 <- 0;Q2 <- 0
	for(m in 1:31)
	{
		HC1 <- (icc2PL(aT,bT,p[m])-icc2PL(aF/A,A*bF+K,p[m]))^2
		HC2 <- (icc2PL(aF,bF,p[m])-icc2PL(aT*A,(bT-K)/A,p[m]))^2
		Q1 <-Q1 + sum(HC1*w[m])
		Q2 <-Q2 + sum(HC2*w[m])
	}
	Q <- Q1 + Q2
	return(Q)
}

cf(c(1,0),aF=aF,bF=bF,aT=aT,bT=bT)


res <-nlm(cf,p=c(1.212,0.509),aF=aF,bF=bF,aT=aT,bT=bT)
(A <- res$estimate[1])
(K <- res$estimate[2])

par(mfrow=c(1,2))
for(j in c(3,9))
{
	curve(icc2PL(aT[j],bT[j],x),-4,4,ylim=c(0,1),
	ylab="Probability",xlab="theta",lty=1,lwd=2,main=paste("item",j))
	par(new=T)
	curve(icc2PL(aF[j]/A,(A*bF[j])+K,x),-4,4,ylim=c(0,1),
	ylab="",xlab="",lty=2,lwd=2)
	par(new=T)
	curve(icc2PL(aF[j],bF[j],x),-4,4,ylim=c(0,1),
	ylab="",xlab="",lty=3,lwd=2)
	legend(-4,1.0,c("T","F*","F"),lty=1:3,lwd=2)
}
######################################################################



#stocking and lord(1983)
######################################################################
param <-read.csv("comitem.csv")
aT <- param[,1]
bT <- param[,2]
aF <- param[,3]
bF <- param[,4]

#quadrature point
p <- seq(-4,4,8/30)
w <- numeric(31)
for(i in 1:31)
{
	w[i] <- dnorm(p[i],0,1)*(8/30)
}

#ICC
icc2PL <- function(a,b,theta)
{
	res <-1/(1+exp(-1.7*a*(theta-b)))
	return(res)
}

#criterion function
cf2 <- function(x,aF,bF,aT,bT)
{
	A <- x[1];K <- x[2]
	Q1 <- 0;Q2 <- 0
	for(i in 1:31)
	{
		SLC1 <- (sum(icc2PL(aT,bT,p[i]))-sum(icc2PL(aF/A,A*bF+K,p[i])))^2
		SLC2 <- (sum(icc2PL(aF,bF,p[i]))-sum(icc2PL(aT*A,(bT-K)/A,p[i])))^2
		Q1 <-Q1 + SLC1*w[i]
		Q2 <-Q2 + SLC2*w[i]
	}
	Q <- Q1 + Q2
	return(Q)
}

res <-nlm(cf2,p=c(1.212,0.509),aF=aF,bF=bF,aT=aT,bT=bT)
(A <- res$estimate[1])
(K <- res$estimate[2])

#testinformation
tcc <- function(a,b,theta)
{
	res <- numeric(length(theta))
	for(i in 1:length(theta))
	{
		res[i] <-sum(icc2PL(a,b,theta[i]))
	}
	return(res)
}

curve(tcc(aT,bT,x),-4,4,ylim=c(0,14),
ylab="Score",xlab="theta",lty=1,lwd=2,main="")
par(new=T)
curve(tcc(aF/A,(A*bF)+K,x),-4,4,ylim=c(0,14),
ylab="",xlab="",lty=2,lwd=2)
par(new=T)
curve(tcc(aF,bF,x),-4,4,ylim=c(0,14),
ylab="",xlab="",lty=3,lwd=2)
legend(-4,14.0,c("T","F*","F"),lty=1:3,lwd=2)
####################################################################
